/**
 ****************************************************************************************************
 * @file        myiic.c
 * @author      ԭŶ(ALIENTEK)
 * @version     V1.0
 * @date        2021-10-23
 * @brief       IIC 
 * @license     Copyright (c) 2020-2032, ӿƼ޹˾
 ****************************************************************************************************
 * @attention
 *
 * ʵƽ̨:ԭ ̽ F407
 * Ƶ:www.yuanzige.com
 * ̳:www.openedv.com
 * ˾ַ:www.alientek.com
 * ַ:openedv.taobao.com
 *
 * ޸˵
 * V1.0 20211023
 * һη
 *
 ****************************************************************************************************
 */

#include "myiic.h"


/**
 * @brief       ʼIIC
 * @param       
 * @retval      
 */
void iic_init(void)
{
    iic_stop();     /* ֹͣ豸 */
}

/**
 * @brief       IICʱ,ڿIICдٶ
 * @param       
 * @retval      
 */
static void iic_delay(void)
{
    delay_us(2);    /* 2usʱ, дٶ250Khz */
}

/**
 * @brief       IICʼź
 * @param       
 * @retval      
 */
void iic_start(void)
{
    IIC_SDA(1);
    IIC_SCL(1);
    iic_delay();
    IIC_SDA(0);     /* STARTź: SCLΪʱ, SDAӸ߱ɵ, ʾʼź */
    iic_delay();
    IIC_SCL(0);     /* ǯסI2Cߣ׼ͻ */
    iic_delay();
}

/**
 * @brief       IICֹͣź
 * @param       
 * @retval      
 */
void iic_stop(void)
{
    IIC_SDA(0);     /* STOPź: SCLΪʱ, SDAӵͱɸ, ʾֹͣź */
    iic_delay();
    IIC_SCL(1);
    iic_delay();
    IIC_SDA(1);     /* I2C߽ź */
    iic_delay();
}

/**
 * @brief       ȴӦźŵ
 * @param       
 * @retval      1Ӧʧ
 *              0Ӧɹ
 */
uint8_t iic_wait_ack(void)
{
    uint8_t waittime = 0;
    uint8_t rack = 0;

    IIC_SDA(1);     /* ͷSDA(ʱⲿSDA) */
    iic_delay();
    IIC_SCL(1);     /* SCL=1, ʱӻԷACK */
    iic_delay();

    while (IIC_READ_SDA)    /* ȴӦ */
    {
        waittime++;

        if (waittime > 250)
        {
            iic_stop();
            rack = 1;
            break;
        }
    }

    IIC_SCL(0);     /* SCL=0, ACK */
    iic_delay();
    return rack;
}

/**
 * @brief       ACKӦ
 * @param       
 * @retval      
 */
void iic_ack(void)
{
    IIC_SDA(0);     /* SCL 0 -> 1 ʱ SDA = 0,ʾӦ */
    iic_delay();
    IIC_SCL(1);     /* һʱ */
    iic_delay();
    IIC_SCL(0);
    iic_delay();
    IIC_SDA(1);     /* ͷSDA */
    iic_delay();
}

/**
 * @brief       ACKӦ
 * @param       
 * @retval      
 */
void iic_nack(void)
{
    IIC_SDA(1);     /* SCL 0 -> 1  ʱ SDA = 1,ʾӦ */
    iic_delay();
    IIC_SCL(1);     /* һʱ */
    iic_delay();
    IIC_SCL(0);
    iic_delay();
}

/**
 * @brief       IICһֽ
 * @param       data: Ҫ͵
 * @retval      
 */
void iic_send_byte(uint8_t data)
{
    uint8_t t;
    
    for (t = 0; t < 8; t++)
    {
        IIC_SDA((data & 0x80) >> 7);    /* λȷ */
        iic_delay();
        IIC_SCL(1);
        iic_delay();
        IIC_SCL(0);
        data <<= 1;     /* 1λ,һη */
    }
    IIC_SDA(1);         /* , ͷSDA */
}

/**
 * @brief       IICȡһֽ
 * @param       ack:  ack=1ʱack; ack=0ʱnack
 * @retval      յ
 */
uint8_t iic_read_byte(uint8_t ack)
{
    uint8_t i, receive = 0;

    for (i = 0; i < 8; i++ )    /* 1ֽ */
    {
        receive <<= 1;  /* λ,յλҪ */
        IIC_SCL(1);
        iic_delay();

        if (IIC_READ_SDA)
        {
            receive++;
        }
        
        IIC_SCL(0);
        iic_delay();
    }

    if (!ack)
    {
        iic_nack();     /* nACK */
    }
    else
    {
        iic_ack();      /* ACK */
    }

    return receive;
}

void IIC_ReadBytes(uint8_t deviceAddr, uint8_t writeAddr,uint8_t* data,uint8_t dataLength)
{		
		uint8_t i;	
    iic_start();  

		iic_send_byte(deviceAddr);	    //д
		iic_wait_ack();
		iic_send_byte(writeAddr);
		iic_wait_ack();
		iic_send_byte(deviceAddr|0X01);//ģʽ			   
		iic_wait_ack();
		
		for(i=0;i<dataLength-1;i++)
		{
			data[i] = iic_read_byte(1);
		}		
		data[dataLength-1] = iic_read_byte(0);	
			iic_stop();//һֹͣ 
		delay_ms(10);	 
}

void IIC_Read_One_Byte(uint8_t daddr,uint8_t addr,uint8_t* data)
{				  	  	    																 
    iic_start();  
	
		iic_send_byte(daddr);	   //д
		iic_wait_ack();
		iic_send_byte(addr);//͵ַ
		iic_wait_ack();		 
		iic_start();  	 	   
		iic_send_byte(daddr|0X01);//ģʽ			   
		iic_wait_ack();	 
    *data = iic_read_byte(0);		   
    iic_stop();//һֹͣ	    
}

void IIC_Write_One_Byte(uint8_t daddr,uint8_t addr,uint8_t data)
{				   	  	    																 
    iic_start();  
	
		iic_send_byte(daddr);	    //д
		iic_wait_ack();
		iic_send_byte(addr);//͵ַ
		iic_wait_ack();	   	 										  		   
		iic_send_byte(data);     //ֽ							   
		iic_wait_ack();  		    	   
    iic_stop();//һֹͣ 
		delay_ms(10);	 
}









