#include "max30102.h"

uint8_t max30102_Bus_Write(uint8_t Register_Address, uint8_t Word_Data)
{

		/* ôEEPROM漴ȡָУȡֽ */

		/* 1I2Cź */
		iic_start();

		/* 2ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
		iic_send_byte(max30102_WR_address | I2C_WR);	/* ˴дָ */

		/* 3ACK */
		if (iic_wait_ack() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}

		/* 4ֽڵַ */
		iic_send_byte(Register_Address);
		if (iic_wait_ack() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}
		
		/* 5ʼд */
		iic_send_byte(Word_Data);

		/* 6ACK */
		if (iic_wait_ack() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}

		/* I2Cֹͣź */
		iic_stop();
		return 1;	/* ִгɹ */

cmd_fail: /* ִʧܺмǷֹͣźţӰI2C豸 */
		/* I2Cֹͣź */
		iic_stop();
		return 0;
}



uint8_t max30102_Bus_Read(uint8_t Register_Address)
{
		uint8_t  data;


		/* 1I2Cź */
		iic_start();

		/* 2ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
		iic_send_byte(max30102_WR_address | I2C_WR);	/* ˴дָ */

		/* 3ACK */
		if (iic_wait_ack() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}

		/* 4ֽڵַ */
		iic_send_byte((uint8_t)Register_Address);
		if (iic_wait_ack() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}
		

		/* 6I2Cߡ濪ʼȡ */
		iic_start();

		/* 7ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
		iic_send_byte(max30102_WR_address | I2C_RD);	/* ˴Ƕָ */

		/* 8ACK */
		if (iic_wait_ack() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}

		/* 9ȡ */
		{
			data = iic_read_byte(0);	/* 1ֽ */

			iic_nack();	/* 1ֽڶCPUNACKź(SDA = 1) */
		}
		/* I2Cֹͣź */
		iic_stop();
		return data;	/* ִгɹ dataֵ */

cmd_fail: /* ִʧܺмǷֹͣźţӰI2C豸 */
		/* I2Cֹͣź */
		iic_stop();
		return 0;
}


void max30102_FIFO_ReadWords(uint8_t Register_Address,uint16_t  Word_Data[][2],uint8_t count)
{
		uint8_t i=0;
		uint8_t no = count;
		uint8_t data1, data2;
		/* 1I2Cź */
		iic_start();

		/* 2ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
		iic_send_byte(max30102_WR_address | I2C_WR);	/* ˴дָ */

		/* 3ACK */
		if (iic_wait_ack() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}

		/* 4ֽڵַ */
		iic_send_byte((uint8_t)Register_Address);
		if (iic_wait_ack() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}
		

		/* 6I2Cߡ濪ʼȡ */
		iic_start();

		/* 7ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
		iic_send_byte(max30102_WR_address | I2C_RD);	/* ˴Ƕָ */

		/* 8ACK */
		if (iic_wait_ack() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}

		/* 9ȡ */
		while (no)
		{
			data1 = iic_read_byte(0);	
			iic_ack();
			data2 = iic_read_byte(0);
			iic_ack();
			Word_Data[i][0] = (((uint16_t)data1 << 8) | data2);  //

			
			data1 = iic_read_byte(0);	
			iic_ack();
			data2 = iic_read_byte(0);
			if(1==no)
				iic_nack();	/* 1ֽڶCPUNACKź(SDA = 1) */
			else
				iic_ack();
			Word_Data[i][1] = (((uint16_t)data1 << 8) | data2); 

			no--;	
			i++;
		}
		/* I2Cֹͣź */
		iic_stop();

cmd_fail: /* ִʧܺмǷֹͣźţӰI2C豸 */
		/* I2Cֹͣź */
		iic_stop();
}

void max30102_FIFO_ReadBytes(uint8_t Register_Address,uint8_t* Data)
{	
		max30102_Bus_Read(REG_INTR_STATUS_1);
		max30102_Bus_Read(REG_INTR_STATUS_2);
		
		/* 1I2Cź */
		iic_start();

		/* 2ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
		iic_send_byte(max30102_WR_address | I2C_WR);	/* ˴дָ */

		/* 3ACK */
		if (iic_wait_ack() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}

		/* 4ֽڵַ */
		iic_send_byte((uint8_t)Register_Address);
		if (iic_wait_ack() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}
		

		/* 6I2Cߡ濪ʼȡ */
		iic_start();

		/* 7ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
		iic_send_byte(max30102_WR_address | I2C_RD);	/* ˴Ƕָ */

		/* 8ACK */
		if (iic_wait_ack() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}

		/* 9ȡ */
		Data[0] = iic_read_byte(1);	
		Data[1] = iic_read_byte(1);	
		Data[2] = iic_read_byte(1);	
		Data[3] = iic_read_byte(1);
		Data[4] = iic_read_byte(1);	
		Data[5] = iic_read_byte(0);
		/* 1ֽڶCPUNACKź(SDA = 1) */
		/* I2Cֹͣź */
		iic_stop();

cmd_fail: /* ִʧܺмǷֹͣźţӰI2C豸 */
		/* I2Cֹͣź */
		iic_stop();
}

uint8_t max30102_init(void)
{	
		uint8_t part_id;
		iic_init();
		
		max30102_reset();	
	
		maxim_max30102_read_reg(REG_PART_ID, &part_id);
		printf("part_id:%d\r\n",part_id);
		if(part_id != 0x15)
		{
				return 1;
		}
		
		max30102_Bus_Write(REG_INTR_ENABLE_1,0xc0);	// ж   FIFOжϣFIFOݾжϣرջжϣԴ־ж
		max30102_Bus_Write(REG_INTR_ENABLE_2,0x10); // ڲ¶Ⱦ־ж   д0x02жϣ0x10ر

		max30102_Bus_Write(REG_FIFO_WR_PTR,0x00);  	// FIFO_WR_PTR[4:0]   FIFOдָõ0x00
		max30102_Bus_Write(REG_OVF_COUNTER,0x00);  	// OVF_COUNTER[4:0]   FIFO0üFIFOʱ¼ʧ
		max30102_Bus_Write(REG_FIFO_RD_PTR,0x00);  	// FIFO_RD_PTR[4:0]   FIFOָõ0x00
	
		max30102_Bus_Write(REG_FIFO_CONFIG,0x50);  	// FIFO Configuration  
		//sample avg = 1(ƽֵһʹõ)
		//fifo rollover=true(FIFOȫʱλFIFOΪTRUEFIFOַת㣬FIFOݡλδã0FIFO£ֱFIFO_DATAȡWRITE/READָλñı䡣)
		//fifo almost full = 32(ʣʱFIFOжϣFIFO洢32)
		
		max30102_Bus_Write(REG_MODE_CONFIG,0x03);  	// 0x02 ֻ, 0x03 ֻѪ 0x07 
		max30102_Bus_Write(REG_SPO2_CONFIG,0x27);  	// SPO2_ADC range = 4096nA, SPO2 sample rate (100 Hz), LED pulseWidth (411uS)  
	
		//LED      ֵ-1* 0.2 mA  ,0x24 = 36(ʮ)  36-1*0.2 = 7mA
		max30102_Bus_Write(REG_LED1_PA,0x24);   	  // Choose value for ~ 7mA for LED1      
		max30102_Bus_Write(REG_LED2_PA,0x24);   	  // Choose value for ~ 7mA for LED2
		
		//ӽģʽȣΪ0ӽģʽڼûָڼ׼
		max30102_Bus_Write(REG_PILOT_PA,0x00);   	  // Choose value for ~ 25mA for Pilot LED  


//		max30102_Bus_Write(REG_INTR_ENABLE_1,0xc0);	// ж   FIFOжϣFIFOݾжϣرջж
//		max30102_Bus_Write(REG_INTR_ENABLE_2,0x00); // رڲ¶Ⱦ־ж   д0x02жϣ0x10ر

//		max30102_Bus_Write(REG_FIFO_WR_PTR,0x00);  	// FIFO_WR_PTR[4:0]   FIFOдָõ0x00
//		max30102_Bus_Write(REG_OVF_COUNTER,0x00);  	// OVF_COUNTER[4:0]   FIFO0üFIFOʱ¼ʧ
//		max30102_Bus_Write(REG_FIFO_RD_PTR,0x00);  	// FIFO_RD_PTR[4:0]   FIFOָõ0x00
//	
//		max30102_Bus_Write(REG_FIFO_CONFIG,0x52);  	// FIFO Configuration  
//		//sample avg = 4 (ƽֵһʹõ)
//		//fifo rollover=true(FIFOȫʱλFIFOΪTRUEFIFOַת㣬FIFOݡλδã0FIFO£ֱFIFO_DATAȡWRITE/READָλñı䡣)
//		//fifo almost full = 30(ʣʱFIFOжϣFIFO洢32)
//		
//		max30102_Bus_Write(REG_MODE_CONFIG,0x03);  	// 0x02 ֻred, 0x03 redIR 0x07 redIR
//		
//			
//		
//		max30102_Bus_Write(REG_SPO2_CONFIG,0x27);  	// SPO2_ADC range = 4096nA, SPO2 sample rate (100 Hz), LED pulseWidth (411uS)  
//	
//		//LEDã   ֵ * 0.2 mA  ,0x3C = 60(ʮ)  60*0.2 = 12mA
//		max30102_Bus_Write(REG_LED1_PA,0x3C);   	  // Choose value for ~ 12mA for LED1      
//		max30102_Bus_Write(REG_LED2_PA,0x3C);   	  // Choose value for ~ 12mA for LED2
//		
//		//ӽģʽȣΪ0ӽģʽڼûָڼ׼
//		max30102_Bus_Write(REG_PILOT_PA,0x00);   	  // Choose value for ~ 25mA for Pilot LED  

		return 0;
}

void max30102_reset(void)
{
		while(max30102_Bus_Write(REG_MODE_CONFIG,0x40) != 1)
		{
				printf("reset failed...\r\n");
				delay_ms(1000);
		}
}

void maxim_max30102_write_reg(uint8_t uch_addr, uint8_t uch_data)
{
		IIC_Write_One_Byte(I2C_WRITE_ADDR,uch_addr,uch_data);
}

void maxim_max30102_read_reg(uint8_t uch_addr, uint8_t *puch_data)
{
		IIC_Read_One_Byte(I2C_WRITE_ADDR,uch_addr,puch_data);
}

void maxim_max30102_read_fifo(uint32_t *pun_red_led, uint32_t *pun_ir_led)
{
		uint32_t un_temp;
		unsigned char uch_temp;
		char ach_i2c_data[6];
		*pun_red_led=0;
		*pun_ir_led=0;

		
		//read and clear status register
		maxim_max30102_read_reg(REG_INTR_STATUS_1, &uch_temp);
		maxim_max30102_read_reg(REG_INTR_STATUS_2, &uch_temp);
		
		IIC_ReadBytes(I2C_WRITE_ADDR,REG_FIFO_DATA,(uint8_t *)ach_i2c_data,6);
		
		un_temp=(unsigned char) ach_i2c_data[0];
		un_temp<<=16;
		*pun_red_led+=un_temp;
		un_temp=(unsigned char) ach_i2c_data[1];
		un_temp<<=8;
		*pun_red_led+=un_temp;
		un_temp=(unsigned char) ach_i2c_data[2];
		*pun_red_led+=un_temp;
		
		un_temp=(unsigned char) ach_i2c_data[3];
		un_temp<<=16;
		*pun_ir_led+=un_temp;
		un_temp=(unsigned char) ach_i2c_data[4];
		un_temp<<=8;
		*pun_ir_led+=un_temp;
		un_temp=(unsigned char) ach_i2c_data[5];
		*pun_ir_led+=un_temp;
		*pun_red_led&=0x03FFFF;  //Mask MSB [23:18]
		*pun_ir_led&=0x03FFFF;  //Mask MSB [23:18]
}

float max30102_read_temp(void)
{
		int8_t tempInt;
		uint8_t tempFrac, response = 1;
		
		max30102_Bus_Write(REG_TEMP_CONFIG,0x01);
	
		while(response&0x01)
		{
				response = max30102_Bus_Read(REG_TEMP_CONFIG);
				delay_ms(10);
		}
	
		tempInt = max30102_Bus_Read(REG_TEMP_INTR);
		tempFrac = max30102_Bus_Read(REG_TEMP_FRAC);
	
		return (float)tempInt + ((float)tempFrac * 0.0625f);
}

float max30102_read_tempF(void) 	
{
  float temp = max30102_read_temp();

  if (temp != -999.0f) temp = temp * 1.8f + 32.0f;

  return (temp);
}

uint8_t max30102_read_sp02_PR(struct MAX30102 *max30102_data)
{
	
	
	return 1;
}
