#include "hal_data.h"
#include "bsp_debug_uart.h"
#include "bsp_gpio.h"
#include "max30102.h"
#include "algorithm.h"
#include "bsp_adc.h"
#include "lcd_init.h"
#include "lcd.h"
#include "AnoPTv8Test.h"

FSP_CPP_HEADER
void R_BSP_WarmStart(bsp_warm_start_event_t event);
FSP_CPP_FOOTER

uint32_t aun_ir_buffer[100];     //IR_LED
uint32_t aun_red_buffer[100];    //HR_LED

int32_t n_ir_buffer_length;      //ݳ
int32_t n_sp02;                  //SPO2Ѫֵ
int8_t ch_spo2_valid;            //ʾSP02ǷЧָʾ
int32_t n_heart_rate;            //ֵ
int8_t  ch_hr_valid;             //ʾʼǷЧָʾ

struct MAX30102 max30102_check;

fsp_err_t err = FSP_SUCCESS;
/*******************************************************************************************************************//**
 * main() is generated by the RA Configuration editor and is used to generate threads if an RTOS is used.  This function
 * is called by main() when no RTOS is used.
 **********************************************************************************************************************/
void hal_entry(void)
{    
	n_ir_buffer_length = 100;    //峤Ϊ100洢100spsе5
	int i;                       //ѭʹ
	uint32_t un_min, un_max;     //red LED/Сֵ
	uint32_t ir_min, ir_max;     //ir LED/Сֵ
	uint8_t temp[6];

	GPIO_Init();         //ųʼ
	Debug_UART9_Init();  //ʼ9115200RASCã
	ADC_Init();			 //ADCʼ
	LCD_Init();			 //LCDʼ
	LCD_Fill(0,0,LCD_W,LCD_H,BLACK);

	
	LCD_ShowString(30,6,"%sp02",WHITE,BLACK,12,0);
	LCD_ShowString(100,6,"PR bpm",WHITE,BLACK,12,0);
	LCD_ShowString(13,26,"-",WHITE,BLACK,32,0);
	LCD_ShowString(85,26,"-",WHITE,BLACK,32,0);
	//LCD_ShowString(10,48,"temp::",WHITE,BLACK,12,0);
	
	printf("max30102_init:%d\r\n",max30102_init());
		
	
	while(1)
	{			
		//printf("Read_ADC_Voltage_Value:%f\r\n",Read_ADC_Voltage_Value());
			
		//
		un_min=0x3FFFF;
		un_max=0;
		ir_min=0x3FFFF;
		ir_max=0;

		n_ir_buffer_length=100; 
//		while(INT_READ==0)
//		{
//				max30102_FIFO_ReadBytes(REG_FIFO_DATA,temp);   //ȴֱжŴ
//				break;
//		}
		//delay_ms(100);
		//ȡǰ100ȷźŷΧ
		max30102_Bus_Write(REG_MODE_CONFIG,0x03);     //MAX30102Ϊģʽ
		for(i=0;i<n_ir_buffer_length;i++)
		{
			while(INT_READ==BSP_IO_LEVEL_HIGH);   //ȴֱжŴ
			
			max30102_FIFO_ReadBytes(REG_FIFO_DATA,temp);
			aun_red_buffer[i] =  (long)((long)((long)temp[0]&0x03)<<16) | (long)temp[1]<<8 | (long)temp[2];    // ֵԻʵ
			aun_ir_buffer[i] = (long)((long)((long)temp[3] & 0x03)<<16) |(long)temp[4]<<8 | (long)temp[5];     // ֵԻʵ/
            				
//			printf("red=%d\r\n",aun_red_buffer[i]);
//			printf("ir=%d\r\n",aun_ir_buffer[i]);
					
		}
		max30102_Bus_Write(REG_MODE_CONFIG,0x83);     //MAX30102Ϊģʽ     
		
		//⼸дǷǰݼԽǰΪֵеһݣԱ֤ݵȶ
		aun_red_buffer[0] = aun_red_buffer[5];
		aun_red_buffer[1] = aun_red_buffer[5];
		aun_red_buffer[2] = aun_red_buffer[5];
		
		aun_ir_buffer[0] = aun_ir_buffer[5];
		aun_ir_buffer[1] = aun_ir_buffer[5];
		aun_ir_buffer[2] = aun_ir_buffer[5];
		
		for(i=0;i<n_ir_buffer_length;i++)
		{
			if(un_min>aun_red_buffer[i])
				un_min=aun_red_buffer[i];    //źСֵ
			if(un_max<aun_red_buffer[i])
				un_max=aun_red_buffer[i];    //źֵ
		}
		
		
		for(i=0;i<n_ir_buffer_length;i++)
		{
			if(ir_min>aun_ir_buffer[i])
				ir_min=aun_ir_buffer[i];    //źСֵ
			if(ir_max<aun_ir_buffer[i])
				ir_max=aun_ir_buffer[i];    //źֵ
		}		
		
/*
***λ***	
*/		
//		for(i=0;i<n_ir_buffer_length;i++)
//		{
//			printf("AAA%d",aun_red_buffer[i]-un_min);
////			printf("aun_red_buffer%d\r\n",aun_red_buffer[i]);
////			printf("un_min%d\r\n",un_min);
//			delay_ms(50);				
//		}	
//		for(i=0;i<n_ir_buffer_length;i++)
//		{
//			printf("AAA%d",aun_ir_buffer[i]-ir_min);
////			printf("aun_red_buffer%d\r\n",aun_red_buffer[i]);
////			printf("un_min%d\r\n",un_min);
//			delay_ms(50);				
//		}	

//		for(i=0;i<n_ir_buffer_length;i++)
//		{
//			printf("ir:%d",aun_red_buffer[i]-un_min);
////			printf("aun_red_buffer%d\r\n",aun_red_buffer[i]);
////			printf("un_min%d\r\n",un_min);
////			delay_ms(50);				
//		}	
//		for(i=0;i<n_ir_buffer_length;i++)
//		{
//			printf("red:%d\r\n",aun_ir_buffer[i]-ir_min);
////			printf("aun_red_buffer%d\r\n",aun_red_buffer[i]);
////			printf("un_min%d\r\n",un_min);
////			delay_ms(50);				
//		}	

/*
***λ***	
*/	
		for(i=0;i<n_ir_buffer_length;i++)
		{			
			AnoPTv8TxFrameF1_assistant(aun_ir_buffer[i]-ir_min, aun_red_buffer[i]-un_min);
		}	
		
		
		
		
		
		
		
		
		//un_prev_data=aun_red_buffer[i];
		//ǰ500ʺSpO2(ǰ5)
		maxim_heart_rate_and_oxygen_saturation(aun_ir_buffer, n_ir_buffer_length, aun_red_buffer, &n_sp02, &ch_spo2_valid, &n_heart_rate, &ch_hr_valid); 
		
//		printf("ch_spo2_valid:%d,n_sp02=%d\r\n",ch_spo2_valid,n_sp02);
//		printf("ch_hr_valid:%d,n_heart_rate=%d\r\n",ch_hr_valid,n_heart_rate);
		//delay_ms(1000);
		
		LCD_ShowIntNum(13,26,n_sp02,3,WHITE,BLACK,32);
		if(n_heart_rate < 100)
		{
			LCD_Fill(100,22,LCD_W,LCD_H,BLACK);
			LCD_ShowIntNum(85,26,n_heart_rate,3,WHITE,BLACK,32);
		}
		else if(n_heart_rate >= 100)
			LCD_ShowIntNum(93,26,n_heart_rate,3,WHITE,BLACK,32);
	}
	
#if BSP_TZ_SECURE_BUILD
    /* Enter non-secure code */
    R_BSP_NonSecureEnter();
#endif

}

/*******************************************************************************************************************//**
 * This function is called at various points during the startup process.  This implementation uses the event that is
 * called right before main() to set up the pins.
 *
 * @param[in]  event    Where at in the start up process the code is currently at
 **********************************************************************************************************************/
void R_BSP_WarmStart (bsp_warm_start_event_t event)
{
    if (BSP_WARM_START_RESET == event)
    {
#if BSP_FEATURE_FLASH_LP_VERSION != 0

        /* Enable reading from data flash. */
        R_FACI_LP->DFLCTL = 1U;

        /* Would normally have to wait tDSTOP(6us) for data flash recovery. Placing the enable here, before clock and
         * C runtime initialization, should negate the need for a delay since the initialization will typically take more than 6us. */
#endif
    }

    if (BSP_WARM_START_POST_C == event)
    {
        /* C runtime environment and system clocks are setup. */

        /* Configure pins. */
        R_IOPORT_Open(&g_ioport_ctrl, &IOPORT_CFG_NAME);
    }
}

#if BSP_TZ_SECURE_BUILD

FSP_CPP_HEADER
BSP_CMSE_NONSECURE_ENTRY void template_nonsecure_callable ();

/* Trustzone Secure Projects require at least one nonsecure callable function in order to build (Remove this if it is not required to build). */
BSP_CMSE_NONSECURE_ENTRY void template_nonsecure_callable ()
{

}
FSP_CPP_FOOTER

#endif
